' ChartingLibHelper.cs by Charles Petzold, June 2009

Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Collections
Imports System.Reflection
Imports System.Globalization

Namespace ChartingLib
	Public NotInheritable Class ChartingLibHelper
		Private Shared rand As New Random()

		Private Sub New()
		End Sub
		Public Shared Function GenerateName() As String
			Dim str As String = ""
			Dim num As Integer = rand.Next(3, 11)
			Dim vowels() As Char = { "A"c, "E"c, "I"c, "O"c, "U"c }
			Dim nouns() As Char = { "B"c, "C"c, "D"c, "F"c, "G"c, "H"c, "J"c, "K"c, "L"c, "M"c, "N"c, "P"c, "R"c, "S"c, "T"c, "V"c, "W"c, "Z"c }
			For i As Integer = 0 To num - 1
				Dim ch As Char

				If i Mod 2 = 0 Then
					ch = nouns(rand.Next(nouns.Length))
				Else
					ch = vowels(rand.Next(vowels.Length))
				End If

                str &= IIf(i = 0, ch, Char.ToLower(ch)).ToString()
            Next i
			Return str
		End Function

		Public Shared Function GetRoundedMaximum(ByVal maximum As Double, ParamArray ByVal factors() As Double) As Double
			If maximum <= 0 Then
				Return 0
			End If

			Dim log As Double = Math.Log10(maximum)
			Dim characteristic As Double = Math.Floor(log)
			Dim mantissa As Double = log - Math.Floor(log)
			Dim multFactor As Double = Math.Pow(10, mantissa)

			If multFactor = 1 Then
				multFactor = 1
			Else
				Dim index As Integer

				For index = 0 To factors.Length - 1
					If multFactor < factors(index) Then
						multFactor = factors(index)
						Exit For
					End If
				Next index
				If index = factors.Length Then
					multFactor = 10
				End If
			End If

			Return multFactor * Math.Pow(10, characteristic)
		End Function
	End Class
End Namespace
