' ChildIndexProvider.cs by Charles Petzold, June 2009

Imports Microsoft.VisualBasic
Imports System
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Media

Namespace ChartingLib
	Public Class ChildIndexProvider
		Inherits Decorator
		Private Shared ReadOnly IndexKey As DependencyPropertyKey = DependencyProperty.RegisterReadOnly("Index", GetType(Integer), GetType(ChildIndexProvider), New PropertyMetadata())

		Public Shared ReadOnly IndexProperty As DependencyProperty = IndexKey.DependencyProperty

		Public Sub New()
			AddHandler LayoutUpdated, AddressOf OnLayoutUpdated
		End Sub

		Public Property Index() As Integer
			Protected Set(ByVal value As Integer)
				SetValue(IndexKey, value)
			End Set
			Get
				Return CInt(Fix(GetValue(IndexProperty)))
			End Get
		End Property

		Private Sub OnLayoutUpdated(ByVal sender As Object, ByVal args As EventArgs)
			Dim contPres As ContentPresenter = TryCast(TemplatedParent, ContentPresenter)

			If contPres IsNot Nothing Then
				Dim pnl As Panel = TryCast(VisualTreeHelper.GetParent(contPres), Panel)

				If pnl IsNot Nothing Then
					Index = pnl.Children.IndexOf(contPres)
				End If
			End If
		End Sub
	End Class
End Namespace
