' CircleShifter.cs by Charles Petzold, June 2009

Imports Microsoft.VisualBasic
Imports System
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Media

Namespace ChartingLib
	Public Class CircleShifter
		Inherits Decorator
		Public Shared ReadOnly BasePointProperty As DependencyProperty = DependencyProperty.Register("BasePoint", GetType(Point), GetType(CircleShifter), New FrameworkPropertyMetadata(New Point(), FrameworkPropertyMetadataOptions.AffectsArrange))

		Public Shared ReadOnly RotateTransformProperty As DependencyProperty = DependencyProperty.Register("RotateTransform", GetType(RotateTransform), GetType(CircleShifter), New FrameworkPropertyMetadata(New RotateTransform(), FrameworkPropertyMetadataOptions.AffectsArrange))

		Public Property BasePoint() As Point
			Set(ByVal value As Point)
				SetValue(BasePointProperty, value)
			End Set
			Get
				Return CType(GetValue(BasePointProperty), Point)
			End Get
		End Property

		Public Property RotateTransform() As RotateTransform
			Set(ByVal value As RotateTransform)
				SetValue(RotateTransformProperty, value)
			End Set
			Get
				Return CType(GetValue(RotateTransformProperty), RotateTransform)
			End Get
		End Property

		Protected Overrides Function ArrangeOverride(ByVal arrangeSize As Size) As Size
			Dim rotatedPoint As Point = RotateTransform.Transform(BasePoint)
			Dim arrangePoint As New Point()
			Dim angle As Double = RotateTransform.Angle

			angle = angle Mod 360
			If angle < 0 Then
				angle += 360
			End If

			If angle < 180 Then
				arrangePoint = New Point(rotatedPoint.X, rotatedPoint.Y - (180 - angle) * Child.DesiredSize.Height / 180)
			Else
				arrangePoint = New Point(rotatedPoint.X - Child.DesiredSize.Width, rotatedPoint.Y - (angle - 180) * Child.DesiredSize.Height / 180)
			End If

			Child.Arrange(New Rect(arrangePoint, Child.DesiredSize))
			Return arrangeSize
		End Function
	End Class
End Namespace
