' DoodadPresenter.cs by Charles Petzold, June 2009

Imports Microsoft.VisualBasic
Imports System
Imports System.Windows.Threading

Namespace ChartingLib
	Public Class DoodadPresenter
		Private rand As New Random()

		Public Sub New()
			DoodadCollection = New DoodadCollection()

			For i As Integer = 0 To 19
				Dim doodad As New Doodad()
				doodad.ModelName = ChartingLibHelper.GenerateName()
				doodad.ProductType = rand.Next(4)
				doodad.BaseCost = 50 + 100 * rand.NextDouble()
				doodad.AdditionalCost = 50 * rand.NextDouble()
				doodad.ExtraCost = 25 * rand.NextDouble()
				DoodadCollection.Add(doodad)
			Next i

			Dim tmr As New DispatcherTimer()
			tmr.Interval = TimeSpan.FromSeconds(1)
			AddHandler tmr.Tick, AddressOf OnTimerTick
			tmr.Start()
		End Sub

		Private privateDoodadCollection As DoodadCollection
		Public Property DoodadCollection() As DoodadCollection
			Get
				Return privateDoodadCollection
			End Get
			Set(ByVal value As DoodadCollection)
				privateDoodadCollection = value
			End Set
		End Property

		Private Sub OnTimerTick(ByVal sender As Object, ByVal e As EventArgs)
			Dim whatToChange As Integer = rand.Next(3)
			Dim index As Integer = rand.Next(DoodadCollection.Count)
			Dim doodad As Doodad = DoodadCollection(index)
			Dim increase As Double = 0.95 + 0.1 * rand.NextDouble()

			Select Case whatToChange
				Case 0
					doodad.BaseCost *= increase
				Case 1
					doodad.AdditionalCost *= increase
				Case 2
					doodad.ExtraCost *= increase
			End Select
		End Sub
	End Class
End Namespace
