' Gizmo.cs by Charles Petzold, June 2009

Imports Microsoft.VisualBasic
Imports System
Imports System.ComponentModel

Namespace ChartingLib
	Public Class Gizmo
		Implements INotifyPropertyChanged
		Private name_Renamed As String
		Private revenues_Renamed, scalingFactor_Renamed, scaledRevenues_Renamed As Double

		Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

		Public Property Name() As String
			Set(ByVal value As String)
				If value <> name_Renamed Then
					name_Renamed = value
					OnPropertyChanged("Name")
				End If
			End Set
			Get
				Return name_Renamed
			End Get
		End Property

		Public Property Revenues() As Double
			Set(ByVal value As Double)
				If value <> revenues_Renamed Then
					revenues_Renamed = value
					OnPropertyChanged("Revenues")
					ScaledRevenues = ScalingFactor * revenues_Renamed
				End If
			End Set
			Get
				Return revenues_Renamed
			End Get
		End Property

		Public Property ScalingFactor() As Double
			Set(ByVal value As Double)
				If value <> scalingFactor_Renamed Then
					scalingFactor_Renamed = value
					OnPropertyChanged("ScalingFactor")
					ScaledRevenues = scalingFactor_Renamed * Revenues
				End If
			End Set
			Get
				Return scalingFactor_Renamed
			End Get
		End Property

		Public Property ScaledRevenues() As Double
			Protected Set(ByVal value As Double)
				If value <> scaledRevenues_Renamed Then
					scaledRevenues_Renamed = value
					OnPropertyChanged("ScaledRevenues")
				End If
			End Set
			Get
				Return scaledRevenues_Renamed
			End Get
		End Property

		Protected Overridable Sub OnPropertyChanged(ByVal propertyName As String)
			RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
		End Sub
	End Class
End Namespace
