' ProductSales.cs by Charles Petzold, June 2009

Imports Microsoft.VisualBasic
Imports System
Imports System.ComponentModel

Namespace ChartingLib
	Public Class Product
		Implements INotifyPropertyChanged
		Private name_Renamed As String
		Private sales_Renamed, percentage_Renamed, accumulated_Renamed As Double

		Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

		Public Sub New()
		End Sub

		Public Sub New(ByVal name As String, ByVal sales As Double)
			Me.Name = name
			Me.Sales = sales
		End Sub

		Public Property Name() As String
			Set(ByVal value As String)
				If value <> name_Renamed Then
					name_Renamed = value
					OnPropertyChanged("Name")
				End If
			End Set
			Get
				Return name_Renamed
			End Get
		End Property

		Public Property Sales() As Double
			Set(ByVal value As Double)
				If value <> sales_Renamed Then
					sales_Renamed = value
					OnPropertyChanged("Sales")
				End If
			End Set
			Get
				Return sales_Renamed
			End Get
		End Property

		Public Property Percentage() As Double
			Set(ByVal value As Double)
				If value <> percentage_Renamed Then
					percentage_Renamed = value
					OnPropertyChanged("Percentage")
				End If
			End Set
			Get
				Return percentage_Renamed
			End Get
		End Property

		Public Property Accumulated() As Double
			Set(ByVal value As Double)
				If value <> accumulated_Renamed Then
					accumulated_Renamed = value
					OnPropertyChanged("Accumulated")
				End If
			End Set
			Get
				Return accumulated_Renamed
			End Get
		End Property

		Protected Overridable Sub OnPropertyChanged(ByVal propertyName As String)
			RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
		End Sub
	End Class
End Namespace
