' ProductLineup.cs by Charles Petzold, June 2009

Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.ObjectModel
Imports System.Windows.Threading

Namespace ChartingLib
	Public Class ProductLineup
		Inherits ObservableCollection(Of Product)
		Private Const BaseSales As Double = 1000000
		Private rand As New Random()

		Public Sub New()
			Add(New Product("Widget", BaseSales * rand.NextDouble()))
			Add(New Product("Gizmo", BaseSales * rand.NextDouble()))
			Add(New Product("Doodad", BaseSales * rand.NextDouble()))
			Add(New Product("Thingy", BaseSales * rand.NextDouble()))
			Add(New Product("Geegaw", BaseSales * rand.NextDouble()))
			Add(New Product("Whatchmacallit", BaseSales * rand.NextDouble()))
			Add(New Product("Hoozit", BaseSales * rand.NextDouble()))

			Dim tmr As New DispatcherTimer()
			AddHandler tmr.Tick, AddressOf OnTimerTick
			tmr.Interval = TimeSpan.FromSeconds(1)
			tmr.Start()
		End Sub

		Private Sub OnTimerTick(ByVal sender As Object, ByVal args As EventArgs)
			Dim total As Double = 0

			For Each product As Product In Items
				product.Sales *= 0.95 + 0.1 * rand.NextDouble()
				total += product.Sales
			Next product

			Dim accum As Double = 0

			For Each product As Product In Items
				product.Percentage = product.Sales / total
				product.Accumulated = accum
				accum += product.Percentage
			Next product
		End Sub
	End Class
End Namespace
